Create an AI custom rule

Note: This endpoint is in preview and is subject to change. If you have any feedback, contact Datadog support.

POST https://api.ap1.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.ap2.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.datadoghq.eu/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.ddog-gov.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.us2.ddog-gov.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.uk1.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.us3.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/ruleshttps://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets/{ruleset_name}/rules

Información general

Create a new AI custom rule within a ruleset.

Argumentos

Parámetros de ruta

Nombre

Tipo

Descripción

ruleset_name [required]

string

The ruleset name.

Solicitud

Body Data (required)

Expand All

Campo

Tipo

Descripción

data

object

Request data for creating an AI custom rule.

attributes

object

Attributes for creating an AI custom rule.

name

string

The rule name.

id

string

The rule identifier, which must match the name.

type

enum

AI custom rule resource type. Allowed enum values: ai_rule

{
  "data": {
    "attributes": {
      "name": "my-ai-rule"
    },
    "id": "my-ai-rule",
    "type": "ai_rule"
  }
}

Respuesta

Successfully created

Response containing a single AI custom rule.

Expand All

Campo

Tipo

Descripción

data [required]

object

Response data for an AI custom rule.

attributes [required]

object

An AI custom rule embedded within a ruleset response.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the rule.

last_revision [required]

object

The most recent revision of the rule.

category [required]

enum

Rule category Allowed enum values: SECURITY,BEST_PRACTICES,CODE_STYLE,ERROR_PRONE,PERFORMANCE

checksum [required]

string

Checksum of the revision content.

content [required]

string

Base64-encoded AI model content for this revision.

created_at [required]

date-time

The creation timestamp.

created_by [required]

string

The identifier of the user who created the revision.

cwe [required]

string

The associated CWE identifier.

description [required]

string

Base64-encoded full description.

directories [required]

[string]

Directory patterns this rule applies to.

execution_mode [required]

enum

The execution mode for an AI rule revision. Allowed enum values: auto,manual,always

globs [required]

[string]

File glob patterns this rule applies to.

is_default [required]

boolean

Whether this is a default Datadog rule.

is_published [required]

boolean

Whether this revision is published.

is_testing [required]

boolean

Whether this revision is for testing only.

severity [required]

enum

Rule severity Allowed enum values: ERROR,WARNING,NOTICE

short_description [required]

string

Base64-encoded short description.

version_id [required]

int64

The version identifier for this revision.

name [required]

string

The rule name.

id [required]

string

The rule identifier.

type [required]

enum

AI custom rule resource type. Allowed enum values: ai_rule

{
  "data": {
    "attributes": {
      "created_at": "2024-01-01T00:00:00+00:00",
      "created_by": "example-handle",
      "last_revision": {
        "category": "SECURITY",
        "checksum": "abc123def456",
        "content": "Content",
        "created_at": "2024-01-01T00:00:00+00:00",
        "created_by": "example-handle",
        "cwe": "79",
        "description": "Ruleset description",
        "directories": [
          []
        ],
        "execution_mode": "auto",
        "globs": [
          "**/*.py"
        ],
        "is_default": false,
        "is_published": false,
        "is_testing": false,
        "severity": "ERROR",
        "short_description": "Ruleset short description",
        "version_id": 1
      },
      "name": "my-ai-rule"
    },
    "id": "my-ai-rule",
    "type": "ai_rule"
  }
}

Bad Request

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Unauthorized

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Conflict - rule already exists

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Precondition Failed - validation error or ruleset not found

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Internal Server Error

API error response.

Expand All

Campo

Tipo

Descripción

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Ejemplo de código

                  ## default
# 

# Path parameters
export ruleset_name="my-ai-ruleset"
# Curl command
curl -X POST "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/static-analysis/ai/rulesets/${ruleset_name}/rules" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "DD-API-KEY: ${DD_API_KEY}" \ -H "DD-APPLICATION-KEY: ${DD_APP_KEY}" \ -d @- << EOF { "data": { "attributes": { "name": "my-ai-rule" }, "type": "ai_rule" } } EOF
"""
Create an AI custom rule returns "Successfully created" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.static_analysis_api import StaticAnalysisApi
from datadog_api_client.v2.model.ai_custom_rule_data_type import AiCustomRuleDataType
from datadog_api_client.v2.model.ai_custom_rule_request import AiCustomRuleRequest
from datadog_api_client.v2.model.ai_custom_rule_request_attributes import AiCustomRuleRequestAttributes
from datadog_api_client.v2.model.ai_custom_rule_request_data import AiCustomRuleRequestData

body = AiCustomRuleRequest(
    data=AiCustomRuleRequestData(
        attributes=AiCustomRuleRequestAttributes(
            name="my-ai-rule",
        ),
        id="my-ai-rule",
        type=AiCustomRuleDataType.AI_RULE,
    ),
)

configuration = Configuration()
configuration.unstable_operations["create_ai_custom_rule"] = True
with ApiClient(configuration) as api_client:
    api_instance = StaticAnalysisApi(api_client)
    response = api_instance.create_ai_custom_rule(ruleset_name="my-ai-ruleset", body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" python3 "example.py"
# Create an AI custom rule returns "Successfully created" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.create_ai_custom_rule".to_sym] = true
end
api_instance = DatadogAPIClient::V2::StaticAnalysisAPI.new

body = DatadogAPIClient::V2::AiCustomRuleRequest.new({
  data: DatadogAPIClient::V2::AiCustomRuleRequestData.new({
    attributes: DatadogAPIClient::V2::AiCustomRuleRequestAttributes.new({
      name: "my-ai-rule",
    }),
    id: "my-ai-rule",
    type: DatadogAPIClient::V2::AiCustomRuleDataType::AI_RULE,
  }),
})
p api_instance.create_ai_custom_rule("my-ai-ruleset", body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" rb "example.rb"
// Create an AI custom rule returns "Successfully created" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	body := datadogV2.AiCustomRuleRequest{
		Data: &datadogV2.AiCustomRuleRequestData{
			Attributes: &datadogV2.AiCustomRuleRequestAttributes{
				Name: datadog.PtrString("my-ai-rule"),
			},
			Id:   datadog.PtrString("my-ai-rule"),
			Type: datadogV2.AICUSTOMRULEDATATYPE_AI_RULE.Ptr(),
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.CreateAiCustomRule", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewStaticAnalysisApi(apiClient)
	resp, r, err := api.CreateAiCustomRule(ctx, "my-ai-ruleset", body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `StaticAnalysisApi.CreateAiCustomRule`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `StaticAnalysisApi.CreateAiCustomRule`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" go run "main.go"
// Create an AI custom rule returns "Successfully created" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.StaticAnalysisApi;
import com.datadog.api.client.v2.model.AiCustomRuleDataType;
import com.datadog.api.client.v2.model.AiCustomRuleRequest;
import com.datadog.api.client.v2.model.AiCustomRuleRequestAttributes;
import com.datadog.api.client.v2.model.AiCustomRuleRequestData;
import com.datadog.api.client.v2.model.AiCustomRuleResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.createAiCustomRule", true);
    StaticAnalysisApi apiInstance = new StaticAnalysisApi(defaultClient);

    AiCustomRuleRequest body =
        new AiCustomRuleRequest()
            .data(
                new AiCustomRuleRequestData()
                    .attributes(new AiCustomRuleRequestAttributes().name("my-ai-rule"))
                    .id("my-ai-rule")
                    .type(AiCustomRuleDataType.AI_RULE));

    try {
      AiCustomRuleResponse result = apiInstance.createAiCustomRule("my-ai-ruleset", body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling StaticAnalysisApi#createAiCustomRule");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" java "Example.java"
// Create an AI custom rule returns "Successfully created" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_static_analysis::StaticAnalysisAPI;
use datadog_api_client::datadogV2::model::AiCustomRuleDataType;
use datadog_api_client::datadogV2::model::AiCustomRuleRequest;
use datadog_api_client::datadogV2::model::AiCustomRuleRequestAttributes;
use datadog_api_client::datadogV2::model::AiCustomRuleRequestData;

#[tokio::main]
async fn main() {
    let body = AiCustomRuleRequest::new().data(
        AiCustomRuleRequestData::new()
            .attributes(AiCustomRuleRequestAttributes::new().name("my-ai-rule".to_string()))
            .id("my-ai-rule".to_string())
            .type_(AiCustomRuleDataType::AI_RULE),
    );
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.CreateAiCustomRule", true);
    let api = StaticAnalysisAPI::with_config(configuration);
    let resp = api
        .create_ai_custom_rule("my-ai-ruleset".to_string(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" cargo run
/**
 * Create an AI custom rule returns "Successfully created" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.createAiCustomRule"] = true;
const apiInstance = new v2.StaticAnalysisApi(configuration);

const params: v2.StaticAnalysisApiCreateAiCustomRuleRequest = {
  body: {
    data: {
      attributes: {
        name: "my-ai-rule",
      },
      id: "my-ai-rule",
      type: "ai_rule",
    },
  },
  rulesetName: "my-ai-ruleset",
};

apiInstance
  .createAiCustomRule(params)
  .then((data: v2.AiCustomRuleResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<API-KEY>" DD_APP_KEY="<APP-KEY>" tsc "example.ts"